<template>
  <div class="flex flex-col">
    <div class="flex flex-row justify-start gap-x-3 border p-2">
      <SIcon name="document" class="h-10 w-10 flex-shrink flex-grow-0 self-center" />
      <div v-if="!showJson">
        <p class="text-xl font-bold">{{ item.title ?? item.name }}</p>
        <p>{{ item.description }}</p>
      </div>
      <div v-else>
        <pre>{{ JSON.stringify(item, null, 2) }}</pre>
      </div>
      <div class="ml-auto flex flex-shrink-0 flex-row flex-nowrap items-end gap-4">
        <SLoadingSpinner :class="{ 'opacity-0': !isLoading, 'opacity-100': isLoading }" />
        <SButton
          v-if="keycloakToken?.length"
          class="ml-auto flex-grow-0 self-end"
          variant="secondary"
          :disabled="isLoading"
          @click="fetchSelfDescription(item.claimsGraphUri[0])"
          >{{ isExpanded ? 'Less details' : 'More details' }}</SButton
        >
      </div>
    </div>
    <SJsonPreview class="max-h-[300px] overflow-auto" v-if="isExpanded" :content="previewContent" />
  </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';
import SButton from '../common/SButton.vue';
import SIcon from '../common/SIcon.vue';
import SJsonPreview from '../common/SJsonPreview.vue';
import SLoadingSpinner from '../common/SLoadingSpinner.vue';
import { type FCSearchResult, getSelfDescriptionById } from '../../services/federatedCatalogue';

const keycloakToken = ref<string | null>(null);
const previewContent = ref('');
const isExpanded = ref(false);
const isLoading = ref(false);

onMounted(() => {
  keycloakToken.value = window.localStorage.getItem('KEYCLOAK_ACCESS_TOKEN');
});

defineProps<{
  item: FCSearchResult;
  showJson: boolean;
}>();

const fetchSelfDescription = async (id: string) => {
  if (isExpanded.value) {
    isExpanded.value = false;
    return;
  }
  if (previewContent.value) {
    isExpanded.value = true;
    return;
  }

  if (!keycloakToken.value) {
    return;
  }

  isLoading.value = true;
  const { content } = await getSelfDescriptionById(id, keycloakToken.value);
  previewContent.value = JSON.stringify(content, null, 2);
  isLoading.value = false;
  isExpanded.value = true;
};
</script>
